"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _commander = require("commander");

var _commander2 = _interopRequireDefault(_commander);

var _package = require("../../package.json");

var _package2 = _interopRequireDefault(_package);

var _start = require("./start");

var _start2 = _interopRequireDefault(_start);

var _config = require("./config");

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

process.on("uncaughtException", function (err) {
    process.stderr.write(err + "\n");
    process.exit(12);
});

_commander2.default.version(_package2.default.version).description(_package2.default.description).option("--debug [modules]", "Debug mode");

_commander2.default.command("start").alias("s").description("Start bridges").option("--only <bridge>", "Start only the specific bridge").action(_start2.default);

_commander2.default.command("config").description("Configure ircgram++").action(_config2.default);

_commander2.default.command('*').action(function () {
    process.stderr.write("The command " + _commander2.default.args[0] + ", is not a valid" + (" command, see " + _commander2.default._name + " --help\n"));
    process.exit(1);
});

var mainCLI = function mainCLI(args) {
    _commander2.default.parse(args);

    if (_commander2.default.debug) {
        process.env.DEBUG = _commander2.default.debug;
    }

    if (!_commander2.default.args.length) {
        _commander2.default.help();
    }
};

exports.default = mainCLI;