"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

exports.default = function (args) {

    if (process.getuid() === 0) {
        debug("Running as uid 0");
        if (process.getuid && process.setgid) {
            try {
                debug("Setting uid and gid");
                process.setgid(_config2.default.get('group'));
                process.setuid(_config2.default.get('user'));
            } catch (e) {
                debug("Error setting uid or gid:", e);
                throw new Error("Failed to asssign uid or gid: " + e);
            }
        } else {
            debug("WARNING: setuid or setgid does not exists, running as 0");
        }
    }

    var session = new _session2.default({
        only: args.only || null
    });
    debug("Start session");
    session.start();
};

var _session = require("../session");

var _session2 = _interopRequireDefault(_session);

var _config = require("../config");

var _config2 = _interopRequireDefault(_config);

var _debug = require("debug");

var _debug2 = _interopRequireDefault(_debug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('cli-start');