"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.hookDecorator = exports.declareHook = exports.Hook = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _debug = require("debug");

var _debug2 = _interopRequireDefault(_debug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Promise = require("bluebird");

var hooks = [];

var Hook = exports.Hook = function () {
    function Hook(name) {
        _classCallCheck(this, Hook);

        Hook.validateHookName(name);
        this._name = name;
        this._debug = (0, _debug2.default)("hooks " + name);
        hooks.push(this);
    }

    _createClass(Hook, [{
        key: "before",
        value: function before(data) {
            this._debug("hit before");
            return Promise.resolve(data);
        }
    }, {
        key: "beforeSync",
        value: function beforeSync(data) {
            this._debug("hit before");
            return data;
        }
    }, {
        key: "after",
        value: function after(data) {
            this._debug("hit after");
            return Promise.resolve(data);
        }
    }, {
        key: "afterSync",
        value: function afterSync(data) {
            this._debug("hit after");
            return data;
        }
    }, {
        key: "name",
        get: function get() {
            return this._name;
        }
    }], [{
        key: "validateHookName",
        value: function validateHookName(name) {
            var actual = hooks.find(function (x) {
                return x.name === name;
            });

            if (actual) {
                throw new Error("Hook already exists");
            }

            if (!name.match(/^[a-z]+:[a-z]+(\.[a-z]+)*$/i)) {
                throw new Error("Invalid hook name");
            }
        }
    }]);

    return Hook;
}();

var declareHook = exports.declareHook = function declareHook(name) {
    return new Hook(name);
};

var hookDecorator = exports.hookDecorator = function hookDecorator() {
    (0, _debug2.default)("Averdolaga")(arguments);
    return function decorator(cls, methodName, target) {
        (0, _debug2.default)("Averga")(target.value.bind());
        process.exit(0);
    };
};